异常机制

异常机制

什么是异常

  • 实际工作中,遇到的情况不可能是非常完美的。比如:你写的某个模块,用户输入不一定复合你的要求、你的程序要打开某个文件,这个文件可能不存在或者文件格式不对,你要读取数据库的数据,数据可能是空的等。我们的程序再跑着,内存或硬盘可能就满了,等等。
  • 软件程序在运行过程中,非常可能遇到刚刚提到的这些异常问题,我们叫异常,英文是:Exception,意思是例外。这些,例外情况,或者叫异常,怎么让我们写的程序作出合理的处理。而不至于程序崩溃
  • 异常指程序运行中出现的不期而至的各种情况,如:文件找不到、网络连接失败、非法参数等
  • 异常发生在程序运行期间,它影响了正常的程序执行流程
package com.exception;

public class Demo01 {

    public static void main(String[] args) {
        new Demo01().a();
    }

    public void a(){
        b();
    }
    public void b(){
        a();
    }

}
/*
输出结果:
Exception in thread "main" java.lang.StackOverflowError
	at com.exception.Demo01.b(Demo01.java:13)
	at com.exception.Demo01.a(Demo01.java:10)
	at com.exception.Demo01.b(Demo01.java:13)
	at com.exception.Demo01.a(Demo01.java:10)
	at com.exception.Demo01.b(Demo01.java:13)
	at com.exception.Demo01.a(Demo01.java:10)
	at com.exception.Demo01.b(Demo01.java:13)
*/

简单分类

  • 要理解Java异常处理是如何工作的,你需要掌握以下三种类型的异常:
  • 检查性异常:最具代表的检查性异常是用户错误或问题引起的异常,这是程序员无法预见的。例如要打开一个不存在文件时,一个异常就发生了,这些异常在编译时不能被简单地忽略
  • 运行时异常:运行时异常是可能被程序员避免的异常。与检查性异常相反,运行时异常可以在编译时被忽略
  • 错误ERROR:错误不是异常,而是脱离程序员控制的问题。错误在代码中通常被忽略。例如,当栈溢出时,一个错误就发生了,他们在编译也检查不到的

异常体系结构

  • Java把异常当作对象来处理,并定义一个基类java.lang.Throwable作为所有异常的超类
  • 在Java API中已经定义了许多异常类,这些异常类分为两大类,错误Error和异常Exception

在这里插入图片描述

Error

  • Error类对象由 Java 虚拟机生成并抛出,大多数错误与代码编写者所执行的操作无关
  • Java虚拟机运行错误(Virtual MachineError),当JVM不再有继续执行操作所需的内存资源时,将出现OutOfMemoryError。这些异常发生时,Java虚拟机(JVM)一般会选择线程终止
  • 还有发生在虚拟机试图执行应用时,如类定义错误(NoClassDefFoundError)、连接错误(LinkageError)。这些错误是不可查的,因为他们在应用程序的控制和处理能力之外,而且绝大多数是程序运行时不允许出现的状况

Exception

  • 在Exception分支中有一个重要的子类RuntimeException(运行时异常)
    • ArrayIndexOutOfBoundsException(数组下标越界异常)
    • NullPointerException(空指针异常)
    • ArithmeticException(算术异常)
    • MissingResourceException(丢失资源)
    • ClassNotFoundException(找不到类)等异常,这些异常是不检查异常,程序中可以选择捕获处理,也可以不处理
  • 这些异常一般是由程序逻辑错误引起的,程序应该从逻辑角度尽可能避免这类异常的发生
  • Error和Exception的区别:Error通常是灾难性的致命的错误,是程序无法控制和处理的,当出现这些异常时,Java虚拟机(JVM)一般会选择终止线程;Exception通常情况下是可以被程序处理的,并且在程序中应该尽可能的去处理这些异常

异常处理机制

  • 抛出异常
  • 捕获异常
  • 异常处理五个关键字
    • try、catch、finally、throw、throws
package com.exception;

public class Test {
    public static void main(String[] args) {

        int a = 1;
        int b = 0;
        
        
        
        try {// try 监控区域
            System.out.println(a/b);
        }catch (ArithmeticException e){ // 捕获异常
            System.out.println("程序出现异常,变量b不能为0");
        }finally { // 处理善后工作
            System.out.println("finally");
        }

        // finally  可以不要finally,   假设IO,资源,关闭!
        
    }    
}

捕获多个异常

package com.exception;

public class Test {
    public static void main(String[] args) {

        int a = 1;
        int b = 0;

        // 假设要捕获多个异常: 从小到大!

        try {// try 监控区域
            System.out.println(a/b);
        }catch (Error e){ // catch(想要捕获的异常类型)   捕获异常
            System.out.println("Error");
        }catch (Exception e){
            System.out.println("Exception");
        }
        catch (Throwable t){
            System.out.println("Throwable");
        }finally { // 处理善后工作
            System.out.println("finally");
        }

        // finally  可以不要finally,   假设IO,资源,关闭!

    }

    public void a(){
        b();
    }
    public void b(){
        a();
    }

}

自动生成Try/Catch/Finally

package com.exception;

public class Test2 {
    public static void main(String[] args) {
        int a = 1;
        int b = 0;


        // Ctrl + Alt + T
        try {
            System.out.println(a/b);// 选中该语句用Ctrl + Alt + T
        } catch (Exception e) {
            e.printStackTrace();// 打印错误的栈信息
        } finally {
        }
    }
}

主动抛出异常

public class Test {
    public static void main(String[] args) {

        try {
            new Test().test(1,0);
        } catch (ArithmeticException e) {
            e.printStackTrace();
        } finally {
        }

    }

    // 假设这方法中,处理不了这个异常,方法上抛出异常
    public void test(int a, int b)throws ArithmeticException{
        if (b==0){
            throw new ArithmeticException();// 主动抛出异常,一般在方法中使用
        }
        System.out.println(a/b);
    }

}

自定义异常

  • 使用Java内置的异常类可以描述在编程时出现的大部分异常情况。除此之外,用户还可以自定义异常。用户自定义异常类,只需要继承Exception类即可
  • 在程序中使用自定义异常类,大体可分为以下几个步骤:
    1. 创建自定义异常类
    2. 在方法中通过throw关键字抛出异常对象
    3. 如果在当前抛出异常的方法中处理异常,可以使用try-catch语句捕获并处理;否则在方法的声明处通过throws关键字指明要抛出给方法调用者的异常,继续进行下一步操作
    4. 在出现异常方法的调用者中捕获并处理异常

定义、调用、抛出、捕获

package com.exception.demo02;

// 自定义的异常类
public class MyException extends Exception{

    // 传递数字>10;抛出异常
    private int detail;

    public MyException(int a ) {
        this.detail = a;
    }

    // toString


    @Override
    public String toString() {
        return "MyException{" + detail + "}";
    }
}
package com.exception.demo02;

public class Test {

    // 可能会存在异常的方法

    static void test(int a) throws MyException{

        System.out.println("传递的参数为:" + a);

        if (a>10){
            throw new MyException(a);// 抛出
        }
        System.out.println("OK");
    }

    public static void main(String[] args) {
        try {
            test(11);
        } catch (MyException e) {
            // 增加一些处理异常的代码~
            System.out.println("MyException=>"+e);
        }
    }
}

实际应用中的经验总结

  • 处理运行异常时,采用逻辑去合理规避同时辅助 try-catch 处理
  • 在多重 catch 块后面,可以加一个 catch(Exception)来处理可能会被遗漏的异常
  • 对于不确定的代码,也可以加上 try-catch ,处理潜在的异常
  • 尽量去处理异常,切忌只是简单地调用 printStackTrace() 去打印输出
  • 具体如何处理异常,要根据不同的业务需求和异常类型去决定
  • 尽量添加finally语句块去释放占用的资源
©️2020 CSDN 皮肤主题: 游动-白 设计师: 上身试试 返回首页
实付0元
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、C币套餐、付费专栏及课程。

余额充值